<p align="center">
<picture>
  <source media="(prefers-color-scheme: dark)" srcset="https://github.com/abelljs/abell/assets/30949385/0452e85b-df57-47a3-891c-33068de5c0e2">
  <source media="(prefers-color-scheme: light)" srcset="https://github.com/abelljs/abell/assets/30949385/e9ea17d6-c248-4ef6-9803-fd058b131b4a">
  <img width="512" alt="Abell Logo and Title" src="https://github.com/abelljs/abell/assets/30949385/e9ea17d6-c248-4ef6-9803-fd058b131b4a">
</picture>
</p>

<p align="center"><a href="https://npmjs.org/package/abell"><img alt="Abell Latest Version" src="https://img.shields.io/github/package-json/v/abelljs/abell/main?filename=packages%2Fabell%2Fpackage.json&style=for-the-badge&labelColor=322&logo=npm&label=abell&color=darkred"></a> &nbsp;<a href="https://abelljs.org/"><img alt="Documentation abelljs.org" src="https://img.shields.io/badge/Documentation-abelljs.org-0a30e0?style=for-the-badge&labelColor=19216D&logo=readthedocs&logoColor=eee"/></a> &nbsp;<a href="https://discord.gg/ndsVpRG"><img alt="Discord Join Chat" src="https://img.shields.io/badge/discord-join%20chat-738ADB?style=for-the-badge&logo=discord&logoColor=738ADB&labelColor=225"/></a></p>

<h1 aria-hidden="true"></h1>

<br/>


A Low-Level, Framework Agnostic, Highly Flexible Static-Site-Generator to help you build Static Sites without too much of learning curve.

**Documentation:** https://abelljs.org 


## 📖 &nbsp; Create Abell Project

```sh
npx create-abell my-abell-site
cd my-abell-site
npm run dev
```

Check out https://abelljs.org for complete documentation.

## 🚀 &nbsp; Syntax Example

```vue
<!-- index.abell -->
<html>
  <body>
    I can render JavaScript! Look: {{ 10 + 10 }}
  </body>
</html>
```

Output:
```html
<!-- index.html -->
<html>
  <body>
    I can render JavaScript! Look: 20
  </body>
</html>
```

Learn More at [Syntax Guide](https://abelljs.org/syntax-guide)

### 🤗 Contributing

Check out [CONTRIBUTING.md](https://github.com/abelljs/abell/tree/main/CONTRIBUTING.md)

---

If you like my work, you can sponsor me on GitHub: https://github.com/sponsors/saurabhdaware 🌻
