import { AbstractSyntaxArrayType } from '../../type-utils.js';
/**
 * TODO:
 * CSS Plan-
 *
 * 1. Scope css in the component itself
 * 2. Collect and bundle styles in the plugin (New Vite versions will handle this out of the box)
 *
 */
interface CompileOptions {
    filepath: string;
    cwd?: string;
    outputType?: 'js-string' | 'syntax-blocks';
}
interface HTMLOutputCompileOptions extends CompileOptions {
    outputType: 'syntax-blocks';
}
interface JSOutputCompileOptions extends CompileOptions {
    outputType?: 'js-string';
}
export declare function compile(abellTemplate: string, options: HTMLOutputCompileOptions): AbstractSyntaxArrayType;
export declare function compile(abellTemplate: string, options: JSOutputCompileOptions): string;
export default compile;
